image: docker:20.10.23


services:
  - docker:20.10.23-dind

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  - "export CI_PHP_VERSION=$(echo $CI_JOB_NAME | cut -d ' ' -f 2)"
  - "export CI_DOCKER_TAG=$(echo $CI_JOB_NAME | cut -d ' ' -f 3)"
  - "export CI_DOCKER_TEST_TAG=$(echo ${CI_DOCKER_TAG}-test)"
  - docker pull ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TEST_TAG} || true

stages:
  - build
  - release

variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: /certs

.docker-build: &docker-build
  stage: build
  tags:
    - docker
  script:
    - cd ${CI_PHP_VERSION}
    - docker build --pull --cache-from ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TEST_TAG} -t ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TEST_TAG} -f Dockerfile .
    - docker push ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TEST_TAG}

.docker-release: &docker-release
    stage: release
    tags:
      - docker
    only:
      - master
    script:
      - docker tag ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TEST_TAG} ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TAG}
      - docker push ${CI_REGISTRY_IMAGE}:${CI_DOCKER_TAG}

build 7.4 php74: *docker-build
build 8.0 php80: *docker-build
build 8.1 php81: *docker-build
build 8.2 php82: *docker-build

push 7.4 php74: *docker-release
push 8.0 php80: *docker-release
push 8.1 php81: *docker-release
push 8.2 php82: *docker-release
